# Overview

This charm provides [Cloud Foundry MySQL Broker](https://github.com/cloudfoundry/cf-mysql-broker).

CF MySQL Broker provides MySQL databases as a Cloud Foundry service.
This broker demonstrates the v2 services API between cloud controllers and service brokers.
The broker does not include a MySQL server. Instead, it is meant to be deployed alongside a MySQL server, which it manages.

The charm installs, configures and starts one daemon (upstart job) - cf-mysql-broker.

# Usage

To deploy the MySQL Broker service:

    juju deploy cf-mysql-broker

## Managing MySQL service instance with CLI

You need:
- CF credentials (login and password)
- [CF CLI](https://github.com/cloudfoundry/cli) installed
- Address of the CF Router from your CF deployment
- Address of the MySQL service broker from your CF deployment

1. To get address of the router use Juju CLI:

$juju status cf-go-router

2. Find line in the output like "public-address: 192.168.122.228"
and use the address from it for the next command:

$cf api http://api.192.168.122.228.xip.io

Use this technique to get an address of the MySQL broker. It will be used later.

3. Authenticate yourself in CF (instaed of "user" and "password" use your own values):

$cf auth user password

4. Select a target organisation:

$cf target -o my-org

5. If you have not created a space yet, create one:

$cf create-space my-space

6. Select a target space:

$cf target -s my-space

7. Register the service broker in CF. Use the broker address from the step 2:

$cf create-service-broker mysql cc secret http://192.168.122.229

8. To make service plan public we have to find service plan's guid:

$cf curl /v2/service_plans/`cf curl /v2/service_plans -X 'GET'|grep "\"guid\"" | head -n 1 | sed 's/ *\"guid\": \"//' | sed 's/\", *//'` -X 'PUT' -d '{"public":true}'

9. Create a new MySQL service instance:

$cf create-service p-mysql-local 5mb mysql

You can use the cf services command to list all available service instances that you have created.
$ cf services

Before using a service in application, you must bind the service to your application. Use the cf bind-service command:
$ cf bind-service

## Scale out Usage
Not implemented yet

## Known Limitations and Issues

There are no known limitations.

# Configuration
broker_port - A port on which the mysql broker listens to connections. Default value: 80

# Contact Information
cf-charmers <cf-charmers@lists.launchpad.net>


## Upstream Project

- [Cloud Foundry](http://cloudfoundry.org)
- [Cloud Foundry MySQL Service](https://github.com/cloudfoundry/cf-mysql-release#cloud-foundry-mysql-service)
- [CF MySQL Broker](https://github.com/cloudfoundry/cf-mysql-broker)
